Package org.zkoss.xel.zel

## Class XelELResolver

- java.lang.Object
- - org.zkoss.zel.ELResolver
  - - org.zkoss.xel.zel.XelELResolver

- Direct Known Subclasses:
    `BindELResolver`

      public class XelELResolver
      extends ELResolver

  An XEL implementation of ZEL ELResolver.
  Since:
    6.0.0

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `static class` | `XelELResolver.StandardBeanNameResolver` | It's a class copied from StandardELContext

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected XelContext` | `_ctx` |

    - ### Fields inherited from class org.zkoss.zel.ELResolver

      `RESOLVABLE_AT_DESIGN_TIME, TYPE`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `XelELResolver​(XelContext ctx)` | Constructor.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `java.lang.Class` | `getCommonPropertyType​(ELContext ctx, java.lang.Object base)` |
    `protected ELResolver` | `getELResolver()` |
    `java.util.Iterator<java.beans.FeatureDescriptor>` | `getFeatureDescriptors​(ELContext ctx, java.lang.Object base)` |
    `java.lang.Class<?>` | `getType​(ELContext ctx, java.lang.Object base, java.lang.Object property)` |
    `java.lang.Object` | `getValue​(ELContext ctx, java.lang.Object base, java.lang.Object property)` |
    `protected XelContext` | `getXelContext()` |
    `java.lang.Object` | `invoke​(ELContext ctx, java.lang.Object base, java.lang.Object method, java.lang.Class[] paramTypes, java.lang.Object[] params)` | Invokes a method on the the given object.
    `boolean` | `isReadOnly​(ELContext ctx, java.lang.Object base, java.lang.Object property)` |
    `protected java.lang.Object` | `resolve​(ELContext ctx, java.lang.Object base, java.lang.Object property)` |
    `void` | `setValue​(ELContext ctx, java.lang.Object base, java.lang.Object property, java.lang.Object value)` |

    - ### Methods inherited from class org.zkoss.zel.ELResolver

      `convertToType`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _ctx

          protected final XelContext _ctx

  - ### Constructor Detail

    - #### XelELResolver

          public XelELResolver​(XelContext ctx)

      Constructor.

  - ### Method Detail

    - #### getELResolver

          protected ELResolver getELResolver()

    - #### getXelContext

          protected XelContext getXelContext()

    - #### getValue

          public java.lang.Object getValue​(ELContext ctx,
                                           java.lang.Object base,
                                           java.lang.Object property)
                                    throws PropertyNotFoundException,
                                           ELException

      Specified by:
        `getValue` in class `ELResolver`
      Parameters:
        `ctx` - The EL context for this evaluation
        `base` - The base object on which the property is to be found
        `property` - The property whose value is to be returned
      Returns:
        the value of the provided property
      Throws:
        `PropertyNotFoundException` - If the base/property combination provided to the resolver is one that the resolver can handle but no match was found or a match was found but was not readable
        `ELException` - Wraps any exception throw whilst resolving the property

    - #### resolve

          protected java.lang.Object resolve​(ELContext ctx,
                                             java.lang.Object base,
                                             java.lang.Object property)

    - #### getType

          public java.lang.Class<?> getType​(ELContext ctx,
                                            java.lang.Object base,
                                            java.lang.Object property)
                                     throws PropertyNotFoundException,
                                            ELException

      Specified by:
        `getType` in class `ELResolver`
      Parameters:
        `ctx` - The EL context for this evaluation
        `base` - The base object on which the property is to be found
        `property` - The property whose type is to be returned
      Returns:
        the type of the provided property
      Throws:
        `PropertyNotFoundException` - If the base/property combination provided to the resolver is one that the resolver can handle but no match was found or a match was found but was not readable
        `ELException` - Wraps any exception throw whilst resolving the property

    - #### setValue

          public void setValue​(ELContext ctx,
                               java.lang.Object base,
                               java.lang.Object property,
                               java.lang.Object value)
                        throws PropertyNotFoundException,
                               PropertyNotWritableException,
                               ELException

      Specified by:
        `setValue` in class `ELResolver`
      Parameters:
        `ctx` - The EL context for this evaluation
        `base` - The base object on which the property is to be found
        `property` - The property whose value is to be set
        `value` - The value to set the property to
      Throws:
        `PropertyNotFoundException` - If the base/property combination provided to the resolver is one that the resolver can handle but no match was found
        `PropertyNotWritableException` - If the base/property combination provided to the resolver is one that the resolver can handle but the property was not writable
        `ELException` - Wraps any exception throw whilst resolving the property

    - #### isReadOnly

          public boolean isReadOnly​(ELContext ctx,
                                    java.lang.Object base,
                                    java.lang.Object property)
                             throws PropertyNotFoundException,
                                    ELException

      Specified by:
        `isReadOnly` in class `ELResolver`
      Parameters:
        `ctx` - The EL context for this evaluation
        `base` - The base object on which the property is to be found
        `property` - The property to be checked for read only status
      Returns:
        `true` if the identified property is read only, otherwise `false`
      Throws:
        `PropertyNotFoundException` - If the base/property combination provided to the resolver is one that the resolver can handle but no match was found
        `ELException` - Wraps any exception throw whilst resolving the property

    - #### getFeatureDescriptors

          public java.util.Iterator<java.beans.FeatureDescriptor> getFeatureDescriptors​(ELContext ctx,
                                                                                        java.lang.Object base)

      Specified by:
        `getFeatureDescriptors` in class `ELResolver`

    - #### getCommonPropertyType

          public java.lang.Class getCommonPropertyType​(ELContext ctx,
                                                       java.lang.Object base)

      Specified by:
        `getCommonPropertyType` in class `ELResolver`

    - #### invoke

          public java.lang.Object invoke​(ELContext ctx,
                                         java.lang.Object base,
                                         java.lang.Object method,
                                         java.lang.Class[] paramTypes,
                                         java.lang.Object[] params)
                                  throws MethodNotFoundException

      Description copied from class: `ELResolver`
      Invokes a method on the the given object. This default implementation always returns `null`.
      Overrides:
        `invoke` in class `ELResolver`
      Parameters:
        `ctx` - The EL context for this evaluation
        `base` - The base object on which the method is to be found
        `method` - The method to invoke
        `paramTypes` - The types of the parameters of the method to invoke
        `params` - The parameters with which to invoke the method
      Returns:
        Always `null`
      Throws:
        `MethodNotFoundException`